<?php
function pnMantis_statsblock_init()
{
    // Security
    pnSecAddSchema('pnMantis:stats:', 'Block title::');
}

function pnMantis_statsblock_info()
{
    return array('text_type'      => 'stats',
                 'module'         => 'pnMantis',
                 'text_type_long' => 'Mantis Stats',
                 'allow_multiple' => true,
                 'form_content'   => false,
                 'form_refresh'   => false,
                 'show_preview'   => true);
}


function pnMantis_statsblock_display($blockinfo)
{
    // Security check - important to do this as early as possible to avoid
    // potential security holes or just too much wasted processing.
	// Note that we have Example:Firstblock: as the component.
    if (!pnSecAuthAction(0,
                         'pnMantis:stats:',
                         "$blockinfo[title]::",
                         ACCESS_READ)) {
        return false;
    }

    // Get current content
    $vars = pnBlockVarsFromContent($blockinfo['content']);
    // Defaults
    if (empty($vars['amount'])) {
        $vars['amount'] = 5;
    }
    if (empty($vars['bottomlink'])) {
        $vars['bottomlink'] = 'y';
    }
    if (empty($vars['assigned'])) {
        $vars['assigned'] = 'y';
    }
    if (empty($vars['last'])) {
        $vars['last'] = 'y';
    }
    if (empty($vars['reported'])) {
        $vars['reported'] = 'y';
    }
    if (empty($vars['monitor'])) {
        $vars['monitor'] = 'y';
    }
    if (empty($vars['notassigned'])) {
        $vars['notassigned'] = 'y';
    }


   $currentlang = pnUserGetLang();

  $url = explode('|', $row['url']);
  if (!$url[1]){
      $url[1] = 10;
  }
  if (!$url[2]){
      $url[2] = 'y';
  }
  if (!$url[3]){
      $url[3] = 'y';
  }
  if (!$url[4]){
      $url[4] = 'y';
  }
  if (!$url[5]){
      $url[5] = 'y';
  }
  if (!$url[6]){
      $url[6] = 'y';
  }
  if (!$url[7]){
      $url[7] = 'y';
  }

$amount=$vars['amount'];
$bottomlink = $vars['bottomlink'];
$assigned =  $vars['assigned'];
$reported = $vars['reported'];
$monitor =  $vars['monitor'];
$last =  $vars['last'];
$notassigned =  $vars['notassigned'];

$mantisdb=pnModGetVar('pnMantis', '_mantisdb');
$std_db = $ntPrefix = pnConfigGetVar('dbname');
$username=pnUserGetVar(uname);
$true = mysql_select_db($mantisdb) ;

// first get the userid from mantis
$result99 = mysql_query( "SELECT  id FROM mantis_user_table WHERE username = '$username'" );
$row99 = mysql_fetch_row($result99) ;
$num_rows = mysql_num_rows($result99);
if ($num_rows < 1){
	$userid=0;
}else{
	$userid = $row99[0];
}

if ($notassigned !='n'){
	// Calls not yet assigned
	$result1 = mysql_query("SELECT summary, id,last_updated from mantis_bug_table where  status=10 order by last_updated desc ");
	$items1 = array();
	while (list( $name, $id,$dat) = mysql_fetch_row($result1)) {
		$title = trim($name) ;
        	if (strlen($title) > 30) {
        		$title = substr($title,0,30);
	                $title .= "...";
		}
		$dat1=substr($dat,0,10);
		$id= inc_length($id,7) ;
		$url = "<a href="index.php?module=pnMantis&func=view&idee=".$id." ">".$title."</a>";
		$items1[] = array('url' => $url, 'title' => $title, 'date' => $dat1);
	}
}




if ($assigned !='n'){
	// Calls assigned to the logged on person
	$result1 = mysql_query("SELECT summary, id,last_updated from mantis_bug_table where ( handler_id = '$userid') and status<80 order by last_updated desc limit ".$amount."");
	$items2 = array();
	while (list( $name, $id,$dat) = mysql_fetch_row($result1)) {
		$title = trim($name) ;
	        if (strlen($title) > 30) {
        		$title = substr($title,0,30);
	                $title .= "...";
		}
		$dat1=substr($dat,0,10);
		$id= inc_length($id,7) ;
		$url = "<a href="index.php?module=pnMantis&func=view&idee=".$id." ">".$title."</a>";
		$items2[] = array('url' => $url, 'title' => $title, 'date' => $dat1);
	}
}

if ($monitor !='n'){
	// Calls Monitored by the logged on person
	$result1 = mysql_query("SELECT summary, mantis_bug_table.id,last_updated from mantis_bug_table,
mantis_bug_monitor_table where mantis_bug_table.id=mantis_bug_monitor_table.bug_id and
mantis_bug_monitor_table.user_id = '$userid' and status<80  order by last_updated desc limit ".$amount."");
	$items3 = array();
	while (list( $name, $id,$dat) = mysql_fetch_row($result1)) {
		$title = trim($name) ;
        	if (strlen($title) > 30) {
	        	$title = substr($title,0,30);
        	        $title .= "...";
		}
		$dat1=substr($dat,0,10);
		$id= inc_length($id,7) ;
		$url = "<a href="index.php?module=pnMantis&func=view&idee=".$id." ">".$title."</a>";
		$items3[] = array('url' => $url, 'title' => $title, 'date' => $dat1);
	}
}

if ($reported !='n'){
	// Calls reported by the logged on person
	$result1 = mysql_query("SELECT summary, id,last_updated from mantis_bug_table where reporter_id= '$userid' and status<80 order by last_updated desc limit ".$amount." ");
	$items4 = array();
	while (list( $name, $id,$dat) = mysql_fetch_row($result1)) {
		$title = trim($name) ;
	        if (strlen($title) > 30) {
        		$title = substr($title,0,30);
                	$title .= "...";
		}
		$dat1=substr($dat,0,10);
		$id= inc_length($id,7) ;
		$url = "<a href="index.php?module=pnMantis&func=view&idee=".$id." ">".$title."</a>";
		$items3[] = array('url' => $url, 'title' => $title, 'date' => $dat1);
	}
}


if ($last !='n'){
	// Last Calls reported
	if ($notassigned !='n'){
		$result1 = mysql_query("SELECT summary, id,last_updated from mantis_bug_table where   status<80 and status >10 order by id desc limit ".$amount." ");
	}else{
		$result1 = mysql_query("SELECT summary, id,last_updated from mantis_bug_table where   status<80 order by id desc limit ".$amount." ");
	}
	$items4 = array();
	while (list( $name, $id,$dat) = mysql_fetch_row($result1)) {
		$title = trim($name) ;
	        if (strlen($title) > 25) {
        		$title = substr($title,0,25);
                	$title .= "...";
		}
		$dat1=substr($dat,0,10);
		$id= inc_length($id,7) ;
		$url = "<a href="index.php?module=pnMantis&func=view&idee=".$id." ">".$title."</a>";
		$items3[] = array('url' => $url, 'title' => $title, 'date' => $dat1);
	}
}


$true = mysql_select_db($std_db) ;

// Create output object
// Note that for a block the corresponding module must be passed.
$pnRender =& new pnRender('pnMantis');


// settings
$pnRender->assign('amount', $vars['amount']);
$pnRender->assign('assigned', $vars['assigned']);
$pnRender->assign('bottomlink', $vars['bottomlink']);
$pnRender->assign('reported', $vars['reported']);
$pnRender->assign('monitor', $vars['monitor']);
$pnRender->assign('last', $vars['last']);
$pnRender->assign('notassigned', $vars['notassigned']);


// variables
$pnRender->assign('urllink', "index.php?module=pnMantis&func=main");
$pnRender->assign('items1', $items1);
$pnRender->assign('items2', $items2);
$pnRender->assign('items3', $items3);
$pnRender->assign('items4', $items4);
$pnRender->assign('items5', $items5);



// Populate block info and pass to theme
$blockinfo['content'] = $pnRender->fetch('pnMantis_block_stats.htm');
themesideblock($blockinfo);


}

function pnMantis_statsblock_modify($blockinfo)
{

    // Get current content
    $vars = pnBlockVarsFromContent($blockinfo['content']);
    // Defaults
    if (empty($vars['amount'])) {
        $vars['amount'] = 5;
    }
    if (empty($vars['bottomlink'])) {
        $vars['bottomlink'] = 'y';
    }
    if (empty($vars['assigned'])) {
        $vars['assigned'] = 'y';
    }
    if (empty($vars['last'])) {
        $vars['last'] = 'y';
    }
    if (empty($vars['reported'])) {
        $vars['reported'] = 'y';
    }
    if (empty($vars['monitor'])) {
        $vars['monitor'] = 'y';
    }
    if (empty($vars['notassigned'])) {
        $vars['notassigned'] = 'y';
    }

   // Create output object
	$pnRender =& new pnRender('pnMantis');

// As Admin output changes often, we do not want caching.
	$pnRender->caching = false;


   // assign the approriate values
	$pnRender->assign('amount', $vars['amount']);
	$pnRender->assign('assigned', $vars['assigned']);
	$pnRender->assign('bottomlink', $vars['bottomlink']);
	$pnRender->assign('reported', $vars['reported']);
	$pnRender->assign('monitor', $vars['monitor']);
	$pnRender->assign('last', $vars['last']);
	$pnRender->assign('notassigned', $vars['notassigned']);

    // Return the output that has been generated by this function
	return $pnRender->fetch('pnMantis_block_stats_modify.htm');


}

/**
 * update block settings
 *
 */
function pnMantis_statsblock_update($blockinfo)
{
   // Get current content
    $vars = pnBlockVarsFromContent($blockinfo['content']);

	// alter the corresponding variable
    $vars['amount'] = pnVarCleanFromInput('amount');
    $vars['bottomlink'] = pnVarCleanFromInput('bottomlink');
    $vars['assigned'] = pnVarCleanFromInput('assigned');
    $vars['reported'] = pnVarCleanFromInput('reported');
    $vars['monitor'] = pnVarCleanFromInput('monitor');
    $vars['last'] = pnVarCleanFromInput('last');
    $vars['notassigned'] = pnVarCleanFromInput('notassigned');

	// write back the new contents
    $blockinfo['content'] = pnBlockVarsToContent($vars);

	// clear the block cache
	$pnRender =& new pnRender('pnMantis');
	$pnRender->clear_cache('pnMantis_block_stats.htm');

    return $blockinfo;
}


function inc_length ($num,$length) {

// $num is the number and $lenght is wanted length
   if (strlen($num) >= $length) {
      return $num;
   } else {
      return inc_length (0 . $num , $length);
   }
}


?>
